// -*- C++ -*-
#ifndef __LEMGA_AGGREGATING_BAGGING_H__
#define __LEMGA_AGGREGATING_BAGGING_H__

/** @file
 *  @brief Declare @link lemga::Bagging Bagging@endlink class.
 *
 *  $Id: bagging.h 1907 2004-12-11 00:51:14Z ling $
 */

#include "aggregating.h"

namespace lemga {

/** @brief %Bagging (boostrap aggregating).
 *
 *  %Bagging averages over all hypotheses.
 *  @todo Documentation
 */
class Bagging : public Aggregating {
public:
    explicit Bagging (UINT max = 0);
    explicit Bagging (std::istream& is) { is >> *this; }

    virtual const id_t& id () const;
    virtual Bagging* create () const { return new Bagging(); }
    virtual Bagging* clone () const { return new Bagging(*this); }

    virtual bool support_weighted_data () const { return true; }
    virtual REAL train ();
    virtual Output operator() (const Input&) const;
};

} // namespace lemga

#ifdef  __BAGGING_H__
#warning "This header file may conflict with another `bagging.h' file."
#endif
#define __BAGGING_H__
#endif
